/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"$Id: purge-jobs.c,v 1.2 2006/01/28 07:02:04 njacobs Exp $"

#include <stdio.h>
#include <papi.h>
#include <ipp.h>
#include <ipp-listener.h>

papi_status_t
ipp_purge_jobs(papi_service_t svc, papi_attribute_t **request,
		papi_attribute_t ***response)
{
	papi_status_t status;
	papi_job_t *jobs = NULL;
	papi_attribute_t **operational = NULL;

	char *queue = NULL;

	/* Get operational attributes from the request */
	(void) papiAttributeListGetCollection(request, NULL,
				"operational-attributes-group", &operational);

	/*
	 * The operational-attributes-group must contain:
	 *	printer-uri
	 */
	get_printer_id(operational, &queue, NULL);
	if (queue == NULL) {
		ipp_set_status(response, status, "printer-uri: %s",
			papiStatusString(status));
		return (PAPI_BAD_REQUEST);
	}

	if ((status = papiPrinterPurgeJobs(svc, queue, &jobs)) != PAPI_OK) {
		ipp_set_status(response, status, "purge failed: %s: %s",
				(queue ? queue : "(null)"),
				ipp_svc_status_mesg(svc, status));
	}

	papiJobListFree(jobs);

	return (status);
}
