/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"$Id: library.c,v 1.3 2005/10/31 18:56:45 njacobs Exp $"

/*LINTLIBRARY*/

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <alloca.h>
#include <libintl.h>
#include <papi.h>

static char *calls[] = {
	/* Attribute Calls */
	"papiAttributeListAddValue",
	"papiAttributeListAddBoolean", "papiAttributeListAddCollection",
	"papiAttributeListAddDatetime", "papiAttributeListAddInteger",
	"papiAttributeListAddMetadata", "papiAttributeListAddRange",
	"papiAttributeListAddResolution", "papiAttributeListAddString",
	"papiAttributeListDelete",
	"papiAttributeListGetValue", "papiAttributeListGetNext",
	"papiAttributeListFind",
	"papiAttributeListGetBoolean", "papiAttributeListGetCollection",
	"papiAttributeListGetDatetime", "papiAttributeListGetInteger",
	"papiAttributeListGetMetadata", "papiAttributeListGetRange",
	"papiAttributeListGetResolution", "papiAttributeListGetString",
	"papiAttributeListFromString", "papiAttributeListToString",
	"papiAttributeListFree",
	/* Job Calls */
	"papiJobSubmit", "papiJobSubmitByReference", "papiJobValidate",
	"papiJobStreamOpen", "papiJobStreamWrite", "papiJobStreamClose",
	"papiJobQuery", "papiJobModify", "papiJobCancel", "papiJobPromote",
	"papiJobGetAttributeList", "papiJobGetId", "papiJobGetPrinterName",
	"papiJobGetJobTicket",
	"papiJobFree", "papiJobListFree",
	"papiJobHold", "papiJobRelease", "papiJobRestart",
	/* Printer Calls */
	"papiPrintersList", "papiPrinterQuery", "papiPrinterModify",
	"papiPrinterAdd", "papiPrinterRemove",
	"papiPrinterPause", "papiPrinterResume",
	"papiPrinterDisable", "papiPrinterEnable",
	"papiPrinterPurgeJobs", "papiPrinterListJobs",
	"papiPrinterGetAttributeList",
	"papiPrinterFree", "papiPrinterListFree",
	/* Service Calls */
	"papiServiceCreate", "papiServiceDestroy",
	"papiServiceGetAppData",
	"papiServiceGetEncryption", "papiServiceGetPassword",
	"papiServiceGetServiceName", "papiServiceGetUserName",
	"papiServiceSetAppData", "papiServiceSetAuthCB",
	"papiServiceSetEncryption", "papiServiceSetPassword",
	"papiServiceSetUserName",
	"papiServiceGetAttributeList", "papiServiceGetStatusMessage",
	/* Misc Calls */
	"papiStatusString",
	"papiLibrarySupportedCall", "papiLibrarySupportedCalls",
	NULL
};

char **
papiLibrarySupportedCalls()
{
	return (calls);
}

char
papiLibrarySupportedCall(const char *name)
{
	int i;

	for (i = 0; calls[i] != NULL; i++)
		if (strcmp(name, calls[i]) == 0)
			return (PAPI_TRUE);

	return (PAPI_FALSE);
}
