/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#ifndef _URI_H
#define	_URI_H

#pragma ident	"$Id: uri.h,v 1.3 2005/09/24 04:08:55 njacobs Exp $"

#ifdef __cplusplus
extern "C" {
#endif

/*
 *	scheme://[[user[:password]@]host[:port]]/path[[#fragment]|[?query]]
 */
typedef struct {
	char *scheme;
	char *scheme_part;
	char *user;
	char *password;
	char *host;
	char *port;
	char *path;
	char *fragment;
	char *query;
	/* really for testing, but left in */
	char *user_part;
	char *host_part;
	char *path_part;
} uri_t;

extern int uri_from_string(char *string, uri_t **uri);
extern int uri_to_string(uri_t *uri, char *buffer, size_t buflen);
extern void uri_free(uri_t *uri);

#ifdef __cplusplus
}
#endif

#endif /* _URI_H */
